# SoQuadMesh Class Reference
[Nodes]

`#include <Inventor/nodes/SoQuadMesh.h>`

Inheritance diagram for SoQuadMesh:

List of all members.

## Detailed Description

The SoQuadMesh class is used to render and optimize a quadrilateral mesh.

This node uses the coordinates in order, either from the state or from the SoQuadMesh::vertexProperty node, to construct a quadrilateral mesh.

The quads are generated in row major order, using the two fields SoQuadMesh::verticesPerColumn and SoQuadMesh::verticesPerRow to specify the mesh. E.g. if SoQuadMesh::verticesPerColumn is 3 and SoQuadMesh::verticesPerRow is 2, two quads will be generated with the first one using (in order) coordinates 0, 1, 3 and 2, the second one using coordinates 2, 3, 5 and 4 (you get three rows of vertices; the first row uses vertices 0 and 1, the second row 2 and 3, and the third row 4 and 5).

Here's a quick and simple usage example code snippet:

      // Vertices for the Quad mesh.
      static float vertices[25][3] = {
        // Row 1
        {-11, 0, 1}, {0, 11, 1}, {11, 0, 1}, {0, -11, 1}, {-11, 0, 1},
        // Row 2
        {-9, 0, 1}, {0, 9, 1}, {9, 0, 1}, {0, -9, 1}, {-9, 0, 1},
        // Row 3
        {-9, 0, -1}, {0, 9, -1}, {9, 0, -1}, {0, -9, -1}, {-9, 0, -1},
        // Row 4
        {-11, 0, -1}, {0, 11, -1}, {11, 0, -1}, {0, -11, -1}, {-11, 0, -1},
        // Row 5
        {-11, 0, 1}, {0, 11, 1}, {11, 0, 1}, {0, -11, 1}, {-11, 0, 1}
      };

      // This function generate an object by using the SoQuadMesh node
      // Return:
      //  SoSeparator *
      static SoSeparator *
      quadMesh(void)
      {
        SoSeparator * qm = new SoSeparator;

        // Define coordinates
        SoCoordinate3 * coords = new SoCoordinate3;
        coords->point.setValues(0, 30, vertices);
        qm->addChild(coords);

        // QuadMesh
        SoQuadMesh * mesh = new SoQuadMesh;
        mesh->verticesPerRow = 5;
        mesh->verticesPerColumn = 5;
        qm->addChild(mesh);

        return qm;
      }

The quadmesh geometry resulting from this code looks like this:

For SoQuadMesh, normals and materials can be bound PER_PART (per row), PER_FACE, PER_VERTEX and OVERALL. The default material binding is OVERALL. The default normal binding is PER_VERTEX.

A note about SoQuadMesh shading: the quads in the mesh are just passed on to OpenGL's GL_QUAD primitive rendering. Under certain circumstances, this can lead to artifacts in how your meshes are shaded. This is an inherent problem with drawing quads in meshes.

There is a work-around solution for the above mentioned problem that can be applied with Coin: by setting the global environment variable `COIN_QUADMESH_PRECISE_LIGHTING` to "1", the quads will be broken up in triangles before rendered, and shading will likely look much better. Be aware that this technique causes rendering of the SoQuadMesh to slow down by an approximate factor of 6.

The "precise lighting" technique is currently limited to work only when SoQuadMesh rendering is parameterized with 3D coordinates, a materialbinding that is not per vertex, and if texture mapping is done is must be without using any of the SoTextureCoordinateFunction subclass nodes.

See also:
  SoTriangleStripSet SoIndexedTriangleStripSet

## Public Member Functions

| SoQuadMesh (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalBundle *nb)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFInt32 | verticesPerColumn
SoSFInt32 | verticesPerRow

## Protected Member Functions

virtual | ~SoQuadMesh ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SbBool | generateDefaultNormals (SoState *, SoNormalCache *)

## Constructor & Destructor Documentation

SoQuadMesh::SoQuadMesh | ( | void |  | ) |

| Constructor.

SoQuadMesh::~SoQuadMesh | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void sogl_qmesh_m3_n3_t1_pl void SoQuadMesh::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNonIndexedShape.

void SoQuadMesh::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoQuadMesh::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

SbBool SoQuadMesh::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalBundle * | nb
| ) | `[virtual]`

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalBundle class. `TRUE` should be returned if normals were generated, `FALSE` otherwise.

Default method returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

void SoQuadMesh::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

void SoQuadMesh::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

SbBool SoQuadMesh::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalCache * | nc
| ) | `[protected, virtual]`

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return `TRUE` if normals were generated, `FALSE` otherwise.

Default method just returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

## Member Data Documentation

SoSFInt32 SoQuadMesh::verticesPerColumn

| Specifies to number of vertices in each column.

SoSFInt32 SoQuadMesh::verticesPerRow

| Specifies the number of vertices in each row.

The documentation for this class was generated from the following files:

- SoQuadMesh.h
- SoQuadMesh.cpp